from nvdaBuiltin.appModules.skype import AppModule as BuiltinAppModule
import api, windowUtils, controlTypes
import ui, tones
from NVDAObjects.IAccessible import IAccessible
import textInfos

class Skype8TextInfo(textInfos.offsets.OffsetsTextInfo):
	def _getStoryLength(self):
		return len(self.obj.name)

	def _getStoryText(self):
		return self.obj.name

class AppModule(BuiltinAppModule):
	__gestures = {}

	__gestures["kb:NVDA+shift+v"] = "announceAppVersion"
	def script_announceAppVersion(self, gesture):
		ui.message("{0} {1}".format(self.productName, self.productVersion))
	# Translators: Input help mode message for the announceAppVersion script.
	script_announceAppVersion.__doc__ = _("Announces the version of the active application")

	def chooseNVDAObjectOverlayClasses(self, obj, clsList):
		major = self.productVersion.split(".", 1)[0]
		if major == "8":
			try: clsList.remove(IAccessible)
			except ValueError: pass
			clsList.insert(0, Skype8IAccessible)
			return
		super(AppModule, self).  chooseNVDAObjectOverlayClasses(obj, clsList)

class Skype8IAccessible(IAccessible):
	def _get_description(self):
		"""Avoid speaking descriptions that duplicate names.
		"""
		desc = super(Skype8IAccessible, self).description
		if not desc or not self.name: return desc
		if desc == self.name: return None
		# For cases like "menu" being added to the name but the two otherwise being equal.
		desclen = len(desc)
		if desclen < len(self.name) and desc == self.name[:desclen]:
			return None
		return desc

	def _get_positionInfo(self):
		"""Avoid speaking things like "2 of 3" when they mean nothing. Applies to the Conversation list.
		"""
		try: id = self.IA2Attributes["id"]
		except: id = ""
		if id.startswith("vc_"):
			# Signifies conversation listItem.
			try:
				cnt = self.parent.childCount
				idx = self.indexInParent
			except: return {}
			idx = cnt -idx +1
			return {"indexInGroup": idx, "similarItemsInGroup": cnt}
			#return {}
		return super(Skype8IAccessible, self).positionInfo

	def _get_next(self):
		if self.indexInParent == self.parent.childCount: return None
		try: return self.parent.getChild(self.indexInParent+1)
		except: return None

	def _get_previous(self):
		if self.indexInParent == 0: return None
		try: return self.parent.getChild(self.indexInParent-1)
		except: return None

	def _get_TextInfo(self):
		if self.role != controlTypes.ROLE_LISTITEM:
			return super(Skype8IAccessible, self).TextInfo
		return Skype8TextInfo

